Index: /branches/PushGP/HeuristicLab.Algorithms.PushGP/HeuristicLab.Algorithms.PushGP/Interpreter/Configuration.cs
===================================================================
--- /branches/PushGP/HeuristicLab.Algorithms.PushGP/HeuristicLab.Algorithms.PushGP/Interpreter/Configuration.cs	(revision 14327)
+++ /branches/PushGP/HeuristicLab.Algorithms.PushGP/HeuristicLab.Algorithms.PushGP/Interpreter/Configuration.cs	(revision 14328)
@@ -4,39 +4,39 @@
 namespace HeuristicLab.Algorithms.PushGP.Interpreter
 {
-    public class Configuration
+    public class Configuration : Generators.Configuration
     {
-        public bool IsBooleanStackEnabled { get; set; } = true;
-        public bool IsIntegerStackEnabled { get; set; } = true;
-        public bool IsFloatStackEnabled { get; set; } = true;
-        public bool IsCodeStackEnabled { get; set; } = true;
-        public bool IsNameStackEnabled { get; set; } = true;
+        public Configuration()
+        {
+            this.IsBooleanStackEnabled = true;
+            this.IsIntegerStackEnabled = true;
+            this.IsFloatStackEnabled = true;
+            this.IsCodeStackEnabled = true;
+            this.IsNameStackEnabled = true;
 
-        public IList<OpCode> AllowedInstructions { get; set; }
+            this.EvalPushLimit = uint.MaxValue;
+            this.MaxPointsInProgram = uint.MaxValue;
+            this.MaxPointsInRandomExpression = uint.MaxValue;
+
+            this.TopLevelPushCode = true;
+            this.TopLevelPopCode = true;
+
+            this.RandomSeedMax = 30081;
+            this.RandomSeedMin = 0;
+            this.RandomSeed = null;
+        }
+
+        public bool IsBooleanStackEnabled { get; set; }
+        public bool IsIntegerStackEnabled { get; set; }
+        public bool IsFloatStackEnabled { get; set; }
+        public bool IsCodeStackEnabled { get; set; }
+        public bool IsNameStackEnabled { get; set; }
+
+        public IList<OpCode> AllowedInclassions { get; set; }
 
         public IList<Expression> PredefinedExpressions { get; set; }
 
         /// <summary>
-        /// The minimum INTEGER that will be produced as an ephemeral random INTEGER constant or from a call to INTEGER.RAND.
-        /// </summary>
-        public long MinRandomInteger { get; set; } = long.MinValue;
-
-        /// <summary>
-        /// The maximum INTEGER that will be produced as an ephemeral random INTEGER constant or from a call to INTEGER.RAND.
-        /// </summary>
-        public long MaxRandomInteger { get; set; } = long.MaxValue;
-
-        /// <summary>
-        /// The minimum FLOAT that will be produced as an ephemeral random FLOAT constant or from a call to FLOAT.RAND.
-        /// </summary>
-        public double MinRandomFloag { get; set; } = double.MinValue;
-
-        /// <summary>
-        /// The maximum FLOAT that will be produced as an ephemeral random FLOAT constant or from a call to FLOAT.RAND.
-        /// </summary>
-        public double MaxRandomFloag { get; set; } = double.MaxValue;
-
-        /// <summary>
         /// This is the maximum allowed number of "executions" in a single top-level call to the interpreter.
-        /// The execution of a single Push instruction counts as one execution, as does the processing of a single literal,
+        /// The execution of a single Push inclassion counts as one execution, as does the processing of a single literal,
         /// as does the descent into one layer of parentheses (that is, the processing of the "(" counts as one execution).
         /// When this limit is exceeded the interpreter aborts immediately, leaving its stacks in the states they were in prior
@@ -44,17 +44,17 @@
         /// is up to the calling program.
         /// </summary>
-        public uint EvalPushLimit { get; set; } = uint.MaxValue;
+        public uint EvalPushLimit { get; set; }
 
         /// <summary>
         /// This is the maximum size of an item on the CODE stack, expressed as a number of points.
-        /// A point is an instruction, a literal, or a pair of parentheses. Any instruction that would cause this limit to be exceeded
-        /// should instead act as a NOOP, leaving all stacks in the states that they were in before the execution of the instruction.
+        /// A point is an inclassion, a literal, or a pair of parentheses. Any inclassion that would cause this limit to be exceeded
+        /// should instead act as a NOOP, leaving all stacks in the states that they were in before the execution of the inclassion.
         /// </summary>
-        public uint MaxPointsInProgram { get; set; } = uint.MaxValue;
+        public uint MaxPointsInProgram { get; set; }
 
         /// <summary>
-        /// The maximum number of points in an expression produced by the CODE.RAND instruction.
+        /// The maximum number of points in an expression produced by the CODE.RAND inclassion.
         /// </summary>
-        public uint MaxPointsInRandomExpression { get; set; } = uint.MaxValue;
+        public uint MaxPointsInRandomExpression { get; set; }
 
         /// <summary>
@@ -62,22 +62,15 @@
         /// will be pushed onto the CODE stack prior to execution.
         /// </summary>
-        public bool TopLevelPushCode { get; set; } = true;
+        public bool TopLevelPushCode { get; set; }
 
         /// <summary>
         /// When TRUE, the CODE stack will be popped at the end of top level calls to the interpreter. The default is FALSE.
         /// </summary>
-        public bool TopLevelPopCode { get; set; } = true;
+        public bool TopLevelPopCode { get; set; }
 
-        /// <summary>
-        /// The probability that the selection of the ephemeral
-        /// random NAME constant for inclusion in randomly generated code will produce a new name
-        /// (rather than a name that was previously generated).
-        /// </summary>
-        public double NewErcNameProbability { get; set; } = 0.5;
+        public ushort RandomSeedMax { get; set; }
+        public ushort RandomSeedMin { get; set; }
 
-        public ushort RandomSeedMax { get; set; } = 30081;
-        public ushort RandomSeedMin { get; set; } = 0;
-
-        public ushort? RandomSeed { get; set; } = null;
+        public ushort? RandomSeed { get; set; }
     }
 }
Index: /branches/PushGP/HeuristicLab.Algorithms.PushGP/HeuristicLab.Algorithms.PushGP/Interpreter/IInterpreter.cs
===================================================================
--- /branches/PushGP/HeuristicLab.Algorithms.PushGP/HeuristicLab.Algorithms.PushGP/Interpreter/IInterpreter.cs	(revision 14328)
+++ /branches/PushGP/HeuristicLab.Algorithms.PushGP/HeuristicLab.Algorithms.PushGP/Interpreter/IInterpreter.cs	(revision 14328)
@@ -0,0 +1,31 @@
+﻿using System.Collections.Generic;
+using System.Threading;
+using System.Threading.Tasks;
+using HeuristicLab.Algorithms.PushGP.Expressions;
+using HeuristicLab.Algorithms.PushGP.Stack;
+
+namespace HeuristicLab.Algorithms.PushGP.Interpreter
+{
+    public interface IInterpreter
+    {
+        IStack<Expression> CodeStack { get; }
+        IStack<Expression> ExecStack { get; }
+        IStack<string> NameStack { get; }
+        IStack<bool> BooleanStack { get; }
+        IStack<long> IntegerStack { get; }
+        IStack<double> FloatStack { get; }
+
+        IDictionary<string, Expression> CustomExpressions { get; }
+
+        void Interpret(string code);
+        Task InterpretAsync(string code, bool paused = false, CancellationToken token = default(CancellationToken));
+        void Interpret(Expression program);
+        Task InterpretAsync(Expression program, bool paused = false, CancellationToken token = default(CancellationToken));
+        Task AbortAndReset();
+        Task AbortAsync();
+        Task PauseAsync();
+        Task ResumeAsync();
+        void Step();
+        void PrintStacks();
+    }
+}
Index: /branches/PushGP/HeuristicLab.Algorithms.PushGP/HeuristicLab.Algorithms.PushGP/Interpreter/Interpreter.cs
===================================================================
--- /branches/PushGP/HeuristicLab.Algorithms.PushGP/HeuristicLab.Algorithms.PushGP/Interpreter/Interpreter.cs	(revision 14327)
+++ /branches/PushGP/HeuristicLab.Algorithms.PushGP/HeuristicLab.Algorithms.PushGP/Interpreter/Interpreter.cs	(revision 14328)
@@ -1,3 +1,4 @@
-﻿using System.Collections.Generic;
+﻿using System;
+using System.Collections.Generic;
 using System.Threading;
 using System.Threading.Tasks;
@@ -7,7 +8,6 @@
 namespace HeuristicLab.Algorithms.PushGP.Interpreter
 {
-    public class PushGPInterpreter : IInterpreterService
+    public class PushGPInterpreter : IInterpreter
     {
-        private static Parser parser = new Parser();
         private Task currentTask;
 
@@ -16,28 +16,30 @@
             this.Configuration = config ?? new Configuration();
 
-            this.CodeStack = new PushGPStack<Expression>();
-            this.ExecStack = new PushGPStack<Expression>();
-            this.NameStack = new PushGPStack<string>();
-            this.BooleanStack = new PushGPStack<bool>();
-            this.IntegerStack = new PushGPStack<long>();
-            this.FloatStack = new PushGPStack<double>();
-        }
-
-        public Configuration Configuration { get; }
-
-        public bool IsPaused { get; private set; } = false;
-        public bool IsAborted { get; private set; } = false;
-        public bool IsRunning => this.ExecStack.Count > 0 && !IsPaused && !IsAborted;
-        public bool IsCompleted => this.ExecStack.Count == 0;
-        public bool CanStep => !IsCompleted && !IsAborted && IsPaused;
-
-        public IStack<Expression> CodeStack { get; }
-        public IStack<Expression> ExecStack { get; }
-        public IStack<string> NameStack { get; }
-        public IStack<bool> BooleanStack { get; }
-        public IStack<long> IntegerStack { get; }
-        public IStack<double> FloatStack { get; }
-
-        public IDictionary<string, Expression> CustomExpressions { get; } = new Dictionary<string, Expression>();
+            this.CodeStack = new PushGPStack<Expression>(128);
+            this.ExecStack = new PushGPStack<Expression>(128);
+            this.NameStack = new PushGPStack<string>(16);
+            this.BooleanStack = new PushGPStack<bool>(16);
+            this.IntegerStack = new PushGPStack<long>(16);
+            this.FloatStack = new PushGPStack<double>(16);
+
+            this.CustomExpressions = new Dictionary<string, Expression>();
+        }
+
+        public Configuration Configuration { get; private set; }
+
+        public bool IsPaused { get; private set; }
+        public bool IsAborted { get; private set; }
+        public bool IsRunning { get { return this.ExecStack.Count > 0 && !IsPaused && !IsAborted; } }
+        public bool IsCompleted { get { return this.ExecStack.Count == 0; } }
+        public bool CanStep { get { return !IsCompleted && !IsAborted && IsPaused; } }
+
+        public IStack<Expression> CodeStack { get; private set; }
+        public IStack<Expression> ExecStack { get; private set; }
+        public IStack<string> NameStack { get; private set; }
+        public IStack<bool> BooleanStack { get; private set; }
+        public IStack<long> IntegerStack { get; private set; }
+        public IStack<double> FloatStack { get; private set; }
+
+        public IDictionary<string, Expression> CustomExpressions { get; private set; }
 
         public void Reset()
@@ -47,4 +49,9 @@
             this.currentTask = null;
 
+            this.Clear();
+        }
+
+        public void Clear()
+        {
             this.ExecStack.Clear();
             this.CodeStack.Clear();
@@ -53,7 +60,103 @@
             this.IntegerStack.Clear();
             this.FloatStack.Clear();
-        }
-
-        public async void AbortAndReset()
+
+            this.CustomExpressions.Clear();
+        }
+
+        public void Interpret(string code)
+        {
+            var program = Encode(code);
+            this.Interpret(program);
+        }
+
+        public Task InterpretAsync(string code, bool paused = false, CancellationToken token = default(CancellationToken))
+        {
+            var program = Encode(code);
+
+            this.currentTask = this.InterpretAsync(program, paused, token);
+
+            return currentTask;
+        }
+
+        public Task InterpretAsync(Expression program, bool paused = false, CancellationToken token = default(CancellationToken))
+        {
+            this.IsPaused = paused;
+            this.currentTask = Task.Run(() => this.Interpret(program), token);
+
+            return currentTask;
+        }
+
+        public void Interpret(Expression program)
+        {
+            this.IsAborted = false;
+
+            /* Push top expression so the loop is able to enter
+             * If the top expression is a single statement then the loop has nothing to do
+             * Otherwise the expand expression will be evaluated and pushes code onto the EXEC stack */
+            this.ExecStack.Push(program);
+            this.CodeStack.Push(program);
+
+            // run top expression
+            this.ExecStack.Pop().Eval(this);
+
+            this.Interpret();
+        }
+
+        private void Interpret()
+        {
+            if (!IsRunning)
+            {
+                return;
+            }
+
+            while (IsRunning)
+            {
+                this.DoStep();
+            }
+
+            if (this.Configuration.TopLevelPushCode)
+            {
+                this.CodeStack.Pop();
+            }
+        }
+
+        private void DoStep()
+        {
+            var expression = this.ExecStack.Pop();
+
+            if (!expression.IsCodeOp)
+            {
+                this.CodeStack.Push(expression);
+            }
+
+            expression.Eval(this);
+
+            if (!expression.IsCodeOp)
+            {
+                CodeStack.Pop();
+            }
+        }
+
+        private Task InterpreteAsync()
+        {
+            this.currentTask = Task.Run(() => this.Interpret());
+
+            return this.currentTask;
+        }
+
+        public async Task AbortAsync()
+        {
+            if (this.IsAborted || this.IsCompleted)
+                return;
+
+            this.IsAborted = true;
+
+            if (this.currentTask != null)
+            {
+                await this.currentTask;
+            }
+        }
+
+        public async Task AbortAndReset()
         {
             await this.AbortAsync();
@@ -61,91 +164,4 @@
         }
 
-        public void Interprete(string code)
-        {
-            var program = Encode(code);
-            this.Interprete(program);
-        }
-
-        public Task InterpreteAsync(string code, CancellationToken token = default(CancellationToken))
-        {
-            var program = Encode(code);
-
-            this.currentTask = this.InterpreteAsync(program, token);
-
-            return currentTask;
-        }
-
-        public Task InterpreteAsync(Expression program, CancellationToken token = default(CancellationToken))
-        {
-            this.currentTask = Task.Run(() => this.Interprete(program), token);
-
-            return currentTask;
-        }
-
-        public void Interprete(Expression program)
-        {
-            this.ExecStack.Push(program);
-            this.CodeStack.Push(program);
-
-            // run top expression
-            this.ExecStack.Pop().Eval(this);
-
-            this.Interprete();
-        }
-
-        private void Interprete()
-        {
-            while (IsRunning)
-            {
-                this.DoStep();
-            }
-
-            if (this.Configuration.TopLevelPushCode)
-            {
-                this.CodeStack.Pop();
-            }
-        }
-
-        private void DoStep()
-        {
-            var expression = this.ExecStack.Pop();
-            var isNotCodeOp = !expression.OpCode.IsCodeOp();
-
-            if (isNotCodeOp)
-            {
-                this.CodeStack.Push(expression);
-            }
-
-            expression.Eval(this);
-
-            if (isNotCodeOp)
-            {
-                CodeStack.Pop();
-            }
-        }
-
-        private Task InterpreteAsync()
-        {
-            this.currentTask = Task.Run(() =>
-            {
-                this.Interprete();
-            });
-
-            return this.currentTask;
-        }
-
-        public async Task AbortAsync()
-        {
-            if (this.IsAborted || this.IsCompleted)
-                return;
-
-            this.IsAborted = true;
-
-            if (this.currentTask != null)
-            {
-                await this.currentTask;
-            }
-        }
-
         public async Task PauseAsync()
         {
@@ -163,5 +179,5 @@
         public Task ResumeAsync()
         {
-            if (this.IsPaused)
+            if (this.IsPaused || !this.IsAborted)
             {
                 this.IsPaused = false;
@@ -177,4 +193,9 @@
             {
                 DoStep();
+
+                if (IsCompleted && this.Configuration.TopLevelPopCode)
+                {
+                    this.CodeStack.Pop();
+                }
             }
         }
@@ -182,5 +203,5 @@
         public static Expression Encode(string code)
         {
-            return parser.Parse(code);
+            return Parser.Parse(code);
         }
 
@@ -212,5 +233,8 @@
         private void PrintStack<T>(string name, IStack<T> stack)
         {
-            System.Console.WriteLine($"--- {name} ---\n{stack}\n---------------------------------------------------");
+            Console.WriteLine(string.Format(
+                "--- {0} ---\n{1}\n---------------------------------------------------",
+                name,
+                stack));
         }
     }
Index: /branches/PushGP/HeuristicLab.Algorithms.PushGP/HeuristicLab.Algorithms.PushGP/OpCodeExtensions.cs
===================================================================
--- /branches/PushGP/HeuristicLab.Algorithms.PushGP/HeuristicLab.Algorithms.PushGP/OpCodeExtensions.cs	(revision 14327)
+++ /branches/PushGP/HeuristicLab.Algorithms.PushGP/HeuristicLab.Algorithms.PushGP/OpCodeExtensions.cs	(revision 14328)
@@ -6,11 +6,6 @@
     public static class OpCodeExtensions
     {
-        public readonly static byte Min = 0;
+        public const byte Min = 0;
         public readonly static byte Max = Enum.GetValues(typeof(OpCode)).Cast<byte>().Last();
-
-        public static bool IsCodeOp(this OpCode opCode)
-        {
-            return opCode >= OpCode.CodeEquals && opCode < OpCode.CodeYankDup;
-        }
     }
 }
Index: /branches/PushGP/HeuristicLab.Algorithms.PushGP/HeuristicLab.Algorithms.PushGP/Parser/Parser.cs
===================================================================
--- /branches/PushGP/HeuristicLab.Algorithms.PushGP/HeuristicLab.Algorithms.PushGP/Parser/Parser.cs	(revision 14327)
+++ /branches/PushGP/HeuristicLab.Algorithms.PushGP/HeuristicLab.Algorithms.PushGP/Parser/Parser.cs	(revision 14328)
@@ -2,24 +2,31 @@
 using System.Globalization;
 using HeuristicLab.Algorithms.PushGP.Expressions;
+using HeuristicLab.Algorithms.PushGP.Expressions.Boolean;
+using HeuristicLab.Algorithms.PushGP.Expressions.Code;
+using HeuristicLab.Algorithms.PushGP.Expressions.Exec;
+using HeuristicLab.Algorithms.PushGP.Expressions.Float;
+using HeuristicLab.Algorithms.PushGP.Expressions.Integer;
+using HeuristicLab.Algorithms.PushGP.Expressions.Name;
 
 namespace HeuristicLab.Algorithms.PushGP
 {
-    public class Parser
+    public static class Parser
     {
-        private readonly CultureInfo cultureInfo = CultureInfo.CreateSpecificCulture("en-US");
+        private static readonly CultureInfo cultureInfo = CultureInfo.CreateSpecificCulture("en-US");
 
-        private const string OpenBrace = "(";
-        private const string CloseBrace = ")";
-        private readonly char[] symbolTrim = new[] { '\r', '\n' };
+        private const string openBrace = "(";
+        private const string closeBrace = ")";
+        private const char delimiter = ' ';
+        private static readonly char[] symbolTrim = new[] { '\r', '\n' };
 
-        public Expression Parse(string source, int startIndex = 0)
+        public static Expression Parse(string source, int startIndex = 0)
         {
-            var symbols = source.Split(' ');
+            var symbols = source.Split(delimiter);
 
             int endIndex;
-            return this.Parse(symbols, 0, out endIndex);
+            return Parse(symbols, 0, out endIndex);
         }
 
-        private Expression Parse(string[] symbols, int startIndex, out int endIndex)
+        private static Expression Parse(string[] symbols, int startIndex, out int endIndex)
         {
             var expressions = new List<Expression>();
@@ -28,4 +35,5 @@
             {
                 var symbol = symbols[i].TrimEnd(symbolTrim);
+
                 if (string.IsNullOrWhiteSpace(symbol))
                 {
@@ -33,5 +41,5 @@
                 }
 
-                if (symbol == OpenBrace)
+                if (symbol == openBrace)
                 {
                     var subExpression = Parse(symbols, i + 1, out endIndex);
@@ -40,5 +48,5 @@
                     continue;
                 }
-                else if (symbol == CloseBrace)
+                else if (symbol == closeBrace)
                 {
                     endIndex = i;
@@ -46,9 +54,4 @@
                         ? new ExecExpandExpression(expressions.ToArray())
                         : new CodeNoopExpression() as Expression;
-                }
-
-                if (string.IsNullOrWhiteSpace(symbol))
-                {
-                    continue;
                 }
 
@@ -61,14 +64,14 @@
                 }
 
-                // instruction
+                // expression
                 OpCode opCode;
                 if (SymbolTable.TryGetOpCode(symbol, out opCode))
                 {
-                    expression = ExpressionCreatorTable.GetCreator(opCode).Invoke();
+                    expression = ExpressionFactory.Create(opCode);
                     expressions.Insert(0, expression);
                     continue;
                 }
 
-                // identifier - custom instruction or named literals
+                // identifier - custom expression or named literals
                 expressions.Insert(0, new NameDefineXExecExpression(symbol));
             }
@@ -80,5 +83,5 @@
         }
 
-        private bool TryParseLiteral(string word, out Expression expression)
+        private static bool TryParseLiteral(string word, out Expression expression)
         {
             long longValue;
